# lines 6-7 are modified, 26-30 are new, 37 is modified, 39 is modified

def calculate_time_delays(times,mags,freqs,subdivision_size=10):
    """Calculates the mid-times of slices of subdivision_size (days), given arrays of observation times, mags, and a list of freqs."""

    # We need a list to store the mid-times and another to store the phases
    time_midpoints, phases = [], []

    # we need lists to store the times and mags of the current slice
    time_slice, mag_slice = [], []

    # we will need to explicitly set our starting time
    time_0 = 0

    # loop over every point in the lightcurve
    for t, y in zip(times, mags):
        # add the time and mag data to the current slice
        time_slice.append(t)
        mag_slice.append(y)

        # we define a new subdivision once it reaches subdivision_size
        if t - time_0 > subdivision_size:
            # append the time midpoint of the subdivision
            time_midpoints.append(np.mean(time_slice))
            
            # determine and add the phases for each frequency
            # the dft_phase function takes times, mags and our freq list
            phis = dft_phase(time_slice, mag_slice, freqs)
            phases.append(phis)

            # reset time zero to be the current time, so we start a new loop for the next subdivision.
            time_0 = t

            # similarly, we recreate empty lists for times and mags
            time_slice, mag_slice = [], []

    return time_midpoints, phases

mid_times, *phases = calculate_time_delays(times,mags,freq_out,10)
